Package com.io7m.waxmill.machines

# Interface WXMFlagsType

All Known Implementing Classes:
  `WXMFlags`

    @Immutable
    public interface WXMFlagsType

The configuration flags associated with a virtual machine.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `default boolean` | `disableMPTableGeneration()` | Disable MP table generation.
  `default boolean` | `exitOnPAUSE()` | Force the guest virtual CPU to exit when a PAUSE instruction is detected.
  `default boolean` | `forceVirtualIOPCIToUseMSI()` | Force virtio PCI device emulations to use MSI interrupts instead of MSI-X interrupts.
  `default boolean` | `generateACPITables()` | Generate ACPI tables.
  `default boolean` | `guestAPICIsX2APIC()` | The guest's local APIC is configured in x2APIC mode.
  `default boolean` | `ignoreUnimplementedModelSpecificRegisters()` | Ignore accesses to unimplemented Model Specific Registers (MSRs).
  `default boolean` | `includeGuestMemoryInCoreFiles()` | Include guest memory in core files.
  `default boolean` | `realTimeClockIsUTC()` | RTC keeps UTC time.
  `default boolean` | `wireGuestMemory()` | Wire guest memory.
  `default boolean` | `yieldCPUOnHLT()` | Yield the virtual CPU thread when a HLT instruction is detected.

- ## Method Details

  - ### includeGuestMemoryInCoreFiles

    @Default default boolean includeGuestMemoryInCoreFiles()
    Include guest memory in core files.
    Returns:
      `true` if guest memory should appear in core files.
    See Also:
      "-C option to bhyve"

  - ### yieldCPUOnHLT

    @Default default boolean yieldCPUOnHLT()
    Yield the virtual CPU thread when a HLT instruction is detected. If this option is not specified, virtual CPUs will use 100% of a host CPU.
    Returns:
      `true` if the virtual CPU should yield on HLT
    See Also:
      "-H option to bhyve"

  - ### exitOnPAUSE

    @Default default boolean exitOnPAUSE()
    Force the guest virtual CPU to exit when a PAUSE instruction is detected.
    Returns:
      `true` if the virtual CPU should exit on PAUSE
    See Also:
      "-P option to bhyve"

  - ### generateACPITables

    @Default default boolean generateACPITables()
    Generate ACPI tables. Required for FreeBSD/amd64 guests.
    Returns:
      `true` if ACPI tables should be generated.
    See Also:
      "-A option to bhyve"

  - ### disableMPTableGeneration

    @Default default boolean disableMPTableGeneration()
    Disable MP table generation.
    Returns:
      `true` if generation should be disabled
    See Also:
      "-Y option to bhyve"

  - ### forceVirtualIOPCIToUseMSI

    @Default default boolean forceVirtualIOPCIToUseMSI()
    Force virtio PCI device emulations to use MSI interrupts instead of MSI-X interrupts.
    Returns:
      `true` if MSI interrupts should be used
    See Also:
      "-W option to bhyve"

  - ### guestAPICIsX2APIC

    @Default default boolean guestAPICIsX2APIC()
    The guest's local APIC is configured in x2APIC mode.
    Returns:
      `true` if the guest's local APIC is configured in x2APIC mode.
    See Also:
      "-x option to bhyve"

  - ### wireGuestMemory

    @Default default boolean wireGuestMemory()
    Wire guest memory.
    Returns:
      `true` if the guest's memory should be wired
    See Also:
      "-S option to bhyve"

  - ### realTimeClockIsUTC

    @Default default boolean realTimeClockIsUTC()
    RTC keeps UTC time.
    Returns:
      `true` if the guest's RTC keeps UTC time.
    See Also:
      "-u option to bhyve"

  - ### ignoreUnimplementedModelSpecificRegisters

    @Default default boolean ignoreUnimplementedModelSpecificRegisters()
    Ignore accesses to unimplemented Model Specific Registers (MSRs). This is intended for debug purposes.
    Returns:
      `true` if unimplemented accesses should be ignored
    See Also:
      "-w option to bhyve"